
UseJPEGImageDecoder()
UsePNGImageDecoder()
UseTGAImageDecoder()

Structure RAWHEADER
	ID.l
	Width.l
	Height.l
	DataPos.l
EndStructure

Procedure.l RGBA(Color.l)
	ProcedureReturn Red(Color) << 24 | Green(Color) << 16 | Blue(Color) << 8 | ((Color >> 24) & $FF)
EndProcedure

Macro RedA(Color)
	(Color >> 24) & $FF
EndMacro
Macro GreenA(Color)
	(Color >> 16) & $FF
EndMacro
Macro BlueA(Color)
	(Color >> 8) & $FF
EndMacro
Macro AlphaA(Color)
	Color & $FF
EndMacro



If CountProgramParameters()
	File.s = ProgramParameter()
	
	If ReadFile(0, File)
		Img.RAWHEADER
		ReadData(0, @Img, SizeOf(RAWHEADER))
		
		If Img\ID <> 'IRAW'
			CloseFile(0)
			MessageRequester("Fehler", "Kein richtiges RAW-File.")
			End
		EndIf
		
		If CreateImage(1, Img\Width, Img\Height)
			FileSeek(0, Img\DataPos)
			
			StartDrawing(ImageOutput(1))
				For y = Img\Height - 1 To 0 Step -1
					For x = 0 To Img\Width - 1
						r.l = ReadByte(0) & $FF
						g.l = ReadByte(0) & $FF
						b.l = ReadByte(0) & $FF
						a.l = ReadByte(0) & $FF
						Plot(x, y, RGB(r, g, b))
					Next
				Next
			StopDrawing()
			
			OpenWindow(0, 0, 0, 500, 500, #PB_Window_SystemMenu|#PB_Window_SizeGadget, "Viewer")
			CreateGadgetList(WindowID(0))
				ImageGadget(2, 0, 0, 500, 500, ImageID(1))
			
			Repeat
				Select WaitWindowEvent()
					Case #PB_Event_CloseWindow
						Quit = #True
					Case #PB_Event_SizeWindow
						ResizeGadget(2, 0, 0, WindowWidth(0), WindowHeight(0))
				EndSelect
			Until Quit
			
			
			FreeImage(1)
		EndIf
		
		CloseFile(0)
	EndIf
EndIf






; IDE Options = PureBasic v4.00 - Beta 4 (Windows - x86)
; CursorPosition = 54
; FirstLine = 19
; Folding = D-
; EnableXP
; Executable = RawViewer.exe